#ifndef GAME_STATE_HH
#define GAME_STATE_HH
#include "vector_object.hh"
#include "gravity_object.hh"
#include "linked_list.hh"
#include "ship.hh"
#include "missile.hh"

typedef List<Vector_Object> vector_list;
typedef List<Gravity_Object> gravity_list;

class game_state {
public:
  void initialize();
  void update();
  void update_screen();
  void add_missile(Missile * missile);
  inline Ship * get_right_ship(){ return right_ship;};
  inline Ship * get_left_ship(){ return left_ship;};
  inline int get_left_player_score(){ return left_player_score;};
  inline int get_right_player_score(){ return right_player_score;};
  
private:
  vector_list v_list;
  gravity_list g_list;
  Ship * left_ship; 
  Ship * right_ship;
  int left_player_score;
  int right_player_score;
};



#endif // GAME_STATE_HH
