#include <math.h>
#include "gravity_object.hh"

const double GC = 1.0;

void 
Gravity_Object::accelerate_object(Vector_Object * object, double time){
  double dx,dy,ax,ay, dist, a;
  if(this == object) 
    return; //don't calculate on self
  dx = get_x() - object->get_x();
  dy = get_y() - object->get_y();
  dist = hypot(dx,dy);
  a = GC*mass/(dist*dist);
  ax = a*dx/dist*time;
  ay = a*dy/dist*time;
  object->accelerate(ax,ay);
}
