#ifndef LINKED_LIST_HH
#define LINKED_LIST_HH
#include <stdio.h>

template <class T> T max(T x,T y){
  return (x>y) ? x : y;
};

template <class T> class Link{
 public:
  T * data;
  Link * next;
  inline T * get_data(){ 
    return data;
  };
  inline Link(T * v, Link * n):data(v),next(n){
  };
};

template <class T> class List{
 public:
  inline void add_element(T * newValue){
    first_link = new Link<T>(newValue, first_link);
  };
  inline T * first_element(){
    Link<T> * first = first_link;
    T * result = first->data;
    first_link = first->next;
    delete first;
    return result;
  };
  
  inline bool is_empty(){
    return first_link == NULL;
  }

  //remove removes the first value that has a pointer that
  //matches remove_value;  Does not delete the value;
  inline bool remove(T * remove_value){
    bool found = false;
    Link<T> * next, * temp = first_link;
    if(temp->data == remove_value){
      first_element();
      found = true;
    } else {
      while(temp->next != NULL){
	if(temp->next->data == remove_value){
	  next = temp->next->next;
	  delete temp->next;
	  temp->next = next;
	  found = true;
	  break;
	}
	temp = temp->next;
      }
    }    
    return found;
  }
  inline void clear(){
    Link<T> * next,* temp = first_link;
    while(temp != NULL){
      next = temp->next;
      delete temp;
      temp = next;
    }
    first_link = NULL;
  }
  inline void clear_and_delete(){
    Link<T> * next,* temp = first_link;
    while(temp != NULL){
      next = temp->next;
      delete temp->data;
      delete temp;
      temp = next;
    }
    first_link = NULL;
  }
  inline void for_each(void (*func)(T * info)){
    Link<T> * temp = first_link;
    while(temp != NULL){
      (*func)(temp->data);
      temp = temp->next;
    }
  }
  inline void for_each_with_ptr(void (*func)(T * info,void * ptr),void * ptr){
    Link<T> * temp = first_link;
    while(temp != NULL){
      (*func)(temp->data,ptr);
      temp = temp->next;
    }
  }

  List(){
    first_link = NULL;
  }
 private:
  Link<T> * first_link;
};

#endif // LINKED_LIST_HH
