#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Menu_.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Menu_Item.H>
#include <stdio.h>
#include "drawing.hh"
#include "game_state.hh"
#include "linked_list.hh"
#include "event_handler.hh"

double screen_width = 640.0,screen_height = 480.0;

game_state * g;

void new_cb(void){
  g->initialize();
};

void exit_cb(Fl_Widget * widget,void * ptr){
  Fl_Double_Window * window = (Fl_Double_Window *)ptr; 
  window->hide();
}

int main(int argc,char **argv){
  Fl_Double_Window window(screen_width,screen_height+30);
  Fl_Menu_Item menuitems[] = {
    { "&File",0,0,0,FL_SUBMENU },
    { "&New", FL_ALT+'n', (Fl_Callback *)new_cb },
    { "&Exit", FL_ALT+'x', exit_cb, &window },
    { 0 },
    { 0 },
  };
  game_state game_state_data;
  g = &game_state_data;
  Fl_Menu_Bar *menubar = new Fl_Menu_Bar(0,0,640,30);
  menubar->menu(menuitems);

  Drawing drawing(10,10+30,screen_width-20,screen_height-20,&game_state_data);
  event_handler event_handler_data(&game_state_data,&drawing);

  //game_state_data.initialize();

  window.end();
  window.show(argc,argv);
  event_handler_data.run();
  return 0;
}


